﻿using Syncfusion.SfChart.XForms;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Xamarin.Forms;
using System.Globalization;
using System.Diagnostics;

namespace ChartSample
{
    public class SimpleSample : ContentPage
    {
        List<ChartDataPoint> Data1;
        private SfChart chart;
        StackLayout layout = new StackLayout() { Padding = new Thickness(5, 15, 0, 5) };
		AreaSeries area;
        public SimpleSample()
        {
            layout.Children.Add(GetChart());
            Content = layout;
        }


        private SfChart GetChart()
        {
            Data1 = new List<ChartDataPoint>();
			Data1.Add(new ChartDataPoint(new DateTime (2015, 1, 1, 17, 0, 0), 19));
			Data1.Add(new ChartDataPoint(new DateTime (2015, 1, 1, 18, 0, 0), 19));
			Data1.Add(new ChartDataPoint(new DateTime (2015, 1, 1, 19, 0, 0), 19.5));
			Data1.Add(new ChartDataPoint(new DateTime (2015, 1, 1, 20, 0, 0), 18));
			Data1.Add(new ChartDataPoint(new DateTime (2015, 1, 1, 21, 0, 0), 16));
			Data1.Add(new ChartDataPoint(new DateTime (2015, 1, 1, 22, 0, 0), 13));
			Data1.Add(new ChartDataPoint(new DateTime (2015, 1, 1, 23, 0, 0), 9));
			Data1.Add(new ChartDataPoint(new DateTime (2015, 1, 2, 00, 0, 0), 9));

            chart = new SfChart();
            chart.HorizontalOptions = LayoutOptions.FillAndExpand;
            chart.VerticalOptions   = LayoutOptions.FillAndExpand;

			DateTimeAxis datAxis = new DateTimeAxis();
			datAxis.Interval	= 1;
			datAxis.IntervalType = DateTimeIntervalType.Hours;
			datAxis.ShowMajorGridLines	= false;
			datAxis.LabelRotationAngle = 300;
			datAxis.AxisLineStyle = new ChartLineStyle (){ StrokeWidth = 0 };
			datAxis.MajorTickStyle = new ChartAxisTickStyle (){ TickSize = 0 };

			if (Device.OS == TargetPlatform.Windows || Device.OS == TargetPlatform.WinPhone) 
				datAxis.LabelStyle = new ChartAxisLabelStyle (){ LabelFormat = "hh tt", };
			else
				datAxis.LabelStyle = new ChartAxisLabelStyle (){ LabelFormat = "hh a", };
			
			chart.PrimaryAxis = datAxis;

			NumericalAxis numAxis = new NumericalAxis();
			numAxis.IsVisible = false;
			numAxis.Interval = 5;
			numAxis.Minimum = 5;
			numAxis.Maximum = 25;
			chart.SecondaryAxis = numAxis;
			chart.SecondaryAxis.LabelCreated += Chart_SecondaryAxis_LabelCreated;

			NumericalStripLine strip1 = new NumericalStripLine ();
			strip1.Start = 5;
			strip1.Width = 5;
			strip1.FillColor = Color.Transparent;
			strip1.Text = "Bad";
			strip1.LabelStyle.HorizontalAlignment = ChartLabelAlignment.Near;

			NumericalStripLine strip2 = new NumericalStripLine ();
			strip2.Start = 10;
			strip2.Width = 5;
			strip2.FillColor = Color.Transparent;
			strip2.Text = "Not OK";
			strip2.LabelStyle.HorizontalAlignment = ChartLabelAlignment.Near;

			NumericalStripLine strip3 = new NumericalStripLine ();
			strip3.Start = 15;
			strip3.Width = 5;
			strip3.FillColor = Color.Transparent;
			strip3.Text = "OK";
			strip3.LabelStyle.HorizontalAlignment = ChartLabelAlignment.Near;

			NumericalStripLine strip4 = new NumericalStripLine ();
			strip4.Start = 20;
			strip4.Width = 5;
			strip4.FillColor = Color.Transparent;
			strip4.Text = "Good";
			strip4.LabelStyle.HorizontalAlignment = ChartLabelAlignment.Near;

			numAxis.StripLines.Add (strip1);
			numAxis.StripLines.Add (strip2);
			numAxis.StripLines.Add (strip3);
			numAxis.StripLines.Add (strip4);

			area = new AreaSeries ();
			area.Color = Color.FromRgb(178,211,238);
			area.Opacity = 0.6;
			area.StrokeColor = Color.Black;
			area.DataMarker = new ChartDataMarker (){ ShowLabel = false, ShowMarker = true };
			area.ItemsSource = Data1;

            chart.Series.Add(area);
            return chart;
        }

        void Chart_SecondaryAxis_LabelCreated (object sender, ChartAxisLabelEventArgs e)
        {
			switch (e.LabelContent) {
			case "10":
				e.LabelContent = "Bad";
				break;
			case "15":
				e.LabelContent = "Not OK";
				break;
			case "20":
				e.LabelContent = "OK";
				break;
			case "25":
				e.LabelContent = "Good";
				break;
			default:
				e.LabelContent = "";
				break;
			}
        }
			
    }
}